Paper/scripts/applyPatches.sh

71 lines
1.7 KiB
Bash
Raw Normal View History

2016-04-02 05:55:54 +02:00
#!/usr/bin/env bash
PS1="$"
basedir=$(realpath "$1")
2016-04-02 05:55:54 +02:00
workdir="$basedir/work"
echo "Rebuilding Forked projects.... "
function applyPatch {
what=$1
2016-04-02 05:55:54 +02:00
what_name=$(basename "$what")
target=$2
branch=$3
cd "$basedir/$what"
2014-11-28 02:17:45 +01:00
git fetch
2016-03-01 00:09:49 +01:00
git branch -f upstream "$branch" >/dev/null
cd "$basedir"
if [ ! -d "$basedir/$target" ]; then
2016-03-01 00:09:49 +01:00
git clone "$what" "$target"
fi
cd "$basedir/$target"
echo "Resetting $target to $what_name..."
git remote rm upstream > /dev/null 2>&1
2016-04-02 05:55:54 +02:00
git remote add upstream "$basedir/$what" >/dev/null 2>&1
git checkout master 2>/dev/null || git checkout -b master
git fetch upstream >/dev/null 2>&1
git reset --hard upstream/upstream
echo " Applying patches to $target..."
2016-03-01 00:09:49 +01:00
git am --abort >/dev/null 2>&1
git am --3way --ignore-whitespace "$basedir/${what_name}-Patches/"*.patch
if [ "$?" != "0" ]; then
echo " Something did not apply cleanly to $target."
echo " Please review above details and finish the apply then"
echo " save the changes with rebuildPatches.sh"
2013-01-19 09:18:20 +01:00
exit 1
else
echo " Patches applied cleanly to $target"
fi
}
2014-11-28 02:17:45 +01:00
# Move into spigot dir
2016-04-02 05:55:54 +02:00
cd "$workdir/Spigot"
basedir=$(pwd)
# Apply Spigot
(
applyPatch ../Bukkit Spigot-API HEAD &&
applyPatch ../CraftBukkit Spigot-Server patched
) || (
echo "Failed to apply Spigot Patches"
exit 1
) || exit 1
# Move out of Spigot
2016-04-02 05:55:54 +02:00
basedir="$1"
cd "$basedir"
2016-03-31 02:50:23 +02:00
echo "Importing MC Dev"
2016-04-02 05:55:54 +02:00
./scripts/importmcdev.sh "$basedir"
2016-03-31 02:50:23 +02:00
# Apply paper
2016-04-02 05:55:54 +02:00
cd "$basedir"
(
2016-04-02 05:55:54 +02:00
applyPatch "work/Spigot/Spigot-API" Paper-API HEAD &&
applyPatch "work/Spigot/Spigot-Server" Paper-Server HEAD
) || (
echo "Failed to apply Paper Patches"
exit 1
) || exit 1